# /usr/bin/python

import time
import random

from Netzwerkzugriff import *
from AntwortParser import *


class FortgeschrittenerSocialbot:
    """
    Dies ist ein Social Bot, der nach dem Aufruf der Methode starten() selbstständig Nachrichten postet. 
    """ 
    def __init__(self, usernameNeu, passwordNeu):
        self._username = usernameNeu
        self._password = passwordNeu
        self._socialbotnet = Netzwerkzugriff("https://www.socialbotnet.de")
        print("Bot angemeldet")
        self._nachrichten = [
            "Mir ist langweilig.",
            "Hat jemand eine gute Filmempfehlung?",
            "Welchen Song findet ihr cool?",
            "Welches Video sollte man sich unbedingt ansehen?",
            "Das Wetter ist heute ja nicht so toll...",
            "Unglaublich...",
            "Was machst du heute?",
            "Hey, hast du einen Instagram Account?"
        ]
        
    def starten(self):
        optionen = 2
        for i in range(20):
            zufallszahl = self.zufallszahlGenerieren(2)
            if zufallszahl == 0:
                self.posten(self._nachrichten[self.zufallszahlGenerieren(len(self._nachrichten))])
            elif zufallszahl == 1:
                self.zufaelligenBeitragKopieren()

            try:
                time.sleep(20 + self.zufallszahlGenerieren(20))
            except Exception:
                pass

    def zufallszahlGenerieren(self, grenze):
        return random.randint(0, grenze - 1)

    def zufaelligenBeitragKopieren(self):
        antwort = self._socialbotnet.GETAnfrageSenden("/api/posts")
        posts = AntwortParser().zuPostArray(antwort)

        zufallsPost = random.choice(posts)

        nachricht = zufallsPost.getMessage()
        print("Folgender Beitrag wird kopiert: ", nachricht)
        self.posten(nachricht)
        

    def posten(self, nachricht):
        self._socialbotnet.POSTAnfrageSenden("/api/post", username=self._username, password=self._password,
                                     message=nachricht)

    def anUserPosten(self, andererUser, nachricht):
        self._socialbotnet.POSTAnfrageSenden("/api/post"+ andererUser, username=self._username, password=self._password,
                                     message=nachricht)


    def liken(self, id):
        self._socialbotnet.POSTAnfrageSenden("/api/like", username=self._username, password=self._password,
                                             postid=str(id))

    def eigenePinnwandLiken(self):
        antwort = self._socialbotnet.GETAnfrageSenden(f"/api/pinnwand/{self._username}")
        posts = AntwortParser().zuPostArray(antwort)
        for post in posts:
            id = post.getId()
            self.liken(id)

# Von dieser Klasse muss mit passenden Anmeldedaten ein Objekt erzeugt werden, 
# dann können entsprechende Methodenaufrufe stattfinden.
